import os
import shutil
import pickle as pk
from datetime import datetime
from .config import Config

config = Config()

class SaveData():    
    
    def save_all(self,
                 df_raw,
                 df_blend, 
                 df_tablet,
                 psd_raw,
                 ar_raw,
                 psd_blend,
                 ar_blend,
                 por_model_data,
                 ts_model_data,):
        
        pk.dump(df_raw, open(os.path.join("./saved_model/", f"{config._name_df_raw}.pkl"), "wb"))
        pk.dump(df_blend, open(os.path.join("./saved_model/", f"{config._name_df_blend}.pkl"), "wb"))
        pk.dump(df_tablet, open(os.path.join("./saved_model/", f"{config._name_df_tablet}.pkl"), "wb"))
        pk.dump(psd_raw, open(os.path.join("./saved_model/", f"{config._name_psd_raw}.pkl"), "wb"))
        pk.dump(ar_raw, open(os.path.join("./saved_model/", f"{config._name_ar_raw}.pkl"), "wb"))
        pk.dump(psd_blend, open(os.path.join("./saved_model/", f"{config._name_psd_blend}.pkl"), "wb"))
        pk.dump(ar_blend, open(os.path.join("./saved_model/", f"{config._name_ar_blend}.pkl"), "wb"))
        pk.dump(por_model_data, open(os.path.join("./saved_model/", f"{config._name_por_model_data}.pkl"), "wb"))
        pk.dump(ts_model_data, open(os.path.join("./saved_model/", f"{config._name_ts_model_data}.pkl"), "wb"))
        # pk.dump(por_model_data_wcsd, open(os.path.join("./saved_model/", f"{config._name_por_model_data_wcsd}.pkl"), "wb"))
        # pk.dump(ts_model_data_wcsd, open(os.path.join("./saved_model/", f"{config._name_ts_model_data_wcsd}.pkl"), "wb"))
        
        # Get the current date and time
        current_time = datetime.now()
        formatted_date = current_time.strftime("%Y%m%d")  # format as 'YYYYMMDD'
        formatted_hour = current_time.strftime("%H")      # format as 'HH'
        
        folder_name = f"{formatted_date}_{formatted_hour}_data"
        print(f"saving models and data in folder {folder_name}")
        
        # Copy files to the newly created directory
        source_directory = "./saved_model/"
        destination_directory = source_directory + folder_name +"/"

        # Create a directory named based on the current date and time        
        os.makedirs(source_directory + folder_name, exist_ok=True)

        # Iterate over files in the source directory and copy files
        for filename in os.listdir(source_directory):
            if filename.endswith(('.pkl', '.h5')):
                source_file_path = os.path.join(source_directory, filename)
                destination_file_path = os.path.join(destination_directory, filename)
                shutil.copyfile(source_file_path, destination_file_path)